UNIT COUP_4;

   {------------------------------------------------------------------------}
   {      logiciel GEOCEAN                                                  }
   {                              menu ECRAN                                }
   {                                                      10/10/93          }
   {------------------------------------------------------------------------}

INTERFACE

{$O+,F+}

USES

   GEO_VAR,                  { GEO     - variables globales communes        }
   GEO_DES,                  { GEO     - procdures communes                }

   COUP_VAR,                 { COUP    - variables globales du module       }
   COUP_INI,                 { COUP    - initialisation                     }
   COUP_DES;                 { COUP    - affichages propres au module       }

{Procedure visu_fond;}
   { bascule : visualise ou efface un fond de carte                         }

Procedure visu_gravi;
   { bascule : visualise ou efface le profil gravi                          }

Procedure visu_topo;
   { bascule : visualise ou efface le profil topo                           }

Procedure visu_sismi;
   { bascule : visualise ou efface le profil sismi                          }

Procedure visu_carte;
   { bascule : visualise ou efface la carte                                 }

Procedure visu_commentaires;
   { bascule : visualise ou efface les textes                               }
   {   provisoirement : concerne la lgende interne de la fentre           }

Procedure visu_graduations;
   { bascule : visualise ou efface les graduations extrieures PROF         }

Procedure visu_compare;
   { bascule : superpose ou non    les profils  lisss et bruts             }

Procedure visu_symboles;
   { bascule : visualise ou efface les symboles lis  la carte             }

Procedure visu_toponymie;
   { bascule : visualise ou efface les noms lis  la carte                 }

Procedure visu_quadr;
   { bascule : visualise ou efface le quadrillage
     concerne aussi la lgende interne de la fentre                        }

Procedure modif_fenetre_graph;
   { prof : modifie position et dimensions de la clture principale         }

Procedure modif_fenetre_coupe ;
   { prof : modifie position et dimensions de la clture coupes             }

Procedure visu_coupes;                       { 4 }
   { bascule : visualise ou efface les coupes dj reprsentes             }

{---------------------------------------------------------------------------}

IMPLEMENTATION

procedure visu_gravi;
   begin
      if visu3
      then begin
         effgravi;
         redess_carte (false);
         redess_pro;
      end else
         if gra
         then
            dess_pro_gra;
   end;

procedure visu_topo;
   begin
      if visu2
      then begin
         efftopo;
         redess_carte (false);
         redess_pro;            { redessiner les autres }
      end else begin
         if top
         then
            dess_pro_top;
      end
   end;

procedure visu_sismi;
   begin
      if visu1
      then begin
         effsismi;
         redess_carte (false);
         redess_pro;            { redessiner les autres }
      end else
         if sis
         then
            dess_pro_sis;
   end;

procedure visu_commentaires;
   begin
      visucomm := not visucomm;
      modicomm := true;
      if reaffiche
      then
         Effacer_tout_redessiner
      else
         if visucomm
         then
            Dessiner_Commentaires (false, true, false)
         else
            effacer_commentaires;
          {  effacer_tout_redessiner;}

      modipar  := true;
   end;

procedure visu_carte;
   begin
      visucarte := not visucarte;
      if  visucarte
      then
         redess_carte (false)
      else
         efface_carte;
      modipar := true;
   end;

procedure visu_symboles;
   begin
      visusymb := not visusymb;

 {  tester }
      if reaffiche
      then
         Effacer_tout_redessiner
      else
         if visucontours and visusymb
         then
            aj_points  (false);

       modipar := true;
   end;

{procedure visu_fond;
   begin
      if visucarte and (gravi or topo)
      then begin
         visufond := not visufond;
         if reaffiche
         then
            Effacer_tout_redessiner
         else
            if visufond
            then
               aj_fond (false)
            else
               redess_carte (false);
         modipar := true;
      end;
   end; }

procedure visu_quadr;
   begin
      if visucarte
      then begin
         ajoute_grille (false, visugrille);
         visugrille := not visugrille;
         modipar  := true;
      end;
   end;

procedure visu_toponymie;
   begin
      visutoponym := not visutoponym;
      modicomm := true;
      if reaffiche
      then
         Effacer_tout_redessiner
      else
         if visutoponym and visucarte
         then
            dessiner_noms (false, true, false)
         else
            effacer_noms;
      modipar     := true;
   end;

procedure visu_graduations;
   begin
      if visucarte
      then begin
         legend  := not legend;
         modipar := true;
      end;
   end;

procedure visu_compare;
   begin
      compare := not compare;
      modipar := true;
      if reaffiche
      then
         Effacer_tout_redessiner;
   end;

procedure modif_fenetre_graph;
   begin
      efface_carte;
      modi_aff_carte;
      visucarte := true;
      modipar   := true;
      recalculer_toponymie_2d;
   end;

procedure modif_fenetre_coupe;
   begin
      if not visupro
      then
         exit;

      if echelle1
      then begin
         efface_profil (2);
         echelle1 := not echelle1;
         recadrer_profils (echelle1);
         dess_profil   (2, false);
      end;

      if sismi and visu1
      then begin
         efface_profil  (1);
         visu1 := true;
         modi_aff_coupe
            (minsismi, maxsismi, titrp1, cp1, cp2, cp3, cp4, ech1);
         cpi1 := cp1;
         cpi2 := cp2;
         cpi3 := cp3;
         cpi4 := cp4;
      end;

      if topo and visu2
      then begin
         efface_profil  (1);
         visu2 := true;
         modi_aff_coupe
            (mintopo, maxtopo, titrp2, ct1, ct2, ct3, ct4, ech2);
         cti1 := ct1;
         cti2 := ct2;
         cti3 := ct3;
         cti4 := ct4;
      end;

      if gravi and visu3
      then begin
         efface_profil  (1);
         visu3 := true;
         modi_aff_coupe
            (ming,    maxg,    titrp3, cg1, cg2, cg3, cg4, ech3);
         cgi1 := cg1;
         cgi2 := cg2;
         cgi3 := cg3;
         cgi4 := cg4;
      end;
     { visucontours := visucarte and not visupro ; carte au premier plan }
      modipar   := true;
  end;

procedure visu_coupes;
   var
      action : integer;
      v1     : boolean;

   begin
      v1  :=    (visu1 and not (visu2 or visu3))      { un seul visible }
             or (visu2 and not (visu1 or visu3))
             or (visu3 and not (visu1 or visu2));

      if     (sis   or gra   or top )               { dj calcul   }
         and (sismi or gravi or topo )             { choix en cours }
      then begin
         if visupro
         then begin
            choix_action (action);               { effacer ou afficher }
            case action of
            1 : begin                            { effacer }
                   if v1
                   then begin
                      efface_profil (1);
                      redess_carte (false);
                   end else begin
                      choix_pro     (choi);
                      efface_profil (choi);
                   end;
                end;
            2 : begin                             { ajouter un profil }
                   choix_pro   (choi);
                   dess_profil (choi, false);
                end;
            end                                   { case action }

         end else begin                { pas de choix, on affiche seulement }
            choix_pro   (choi);
            dess_profil (choi, false);
         end;
         modipar := true;
      end
   end;

END.

{--- GEOCEAN - COUP_4 ------------------------ R.C.- INRP - TOULOUSE - 1993 }
