UNIT COUP_VAR;

   {------------------------------------------------------------------------}
   {      logiciel GEOCEAN                                                  }
   {                  variables globales du module COUP                     }
   {                                                                        }
   {------------------------------------------------------------------------}

INTERFACE

{$O+,F+}

USES
   Dos,                      { TP 70   - units standard Borland            }
   Utildivs,                 { ARX     - utilitaires divers                 }

   GEO_var;                  { GEO     - variables globales GEOCEAN         }

CONST
   extgra               = '.GRA';        { profil d'anomalies               }
   extsis               = '.DAT';        { profil sismique                  }
   extgam               = '.GAM';        { polygones                        }

  {$I coup_msg.pas}         { messages en franais }

VAR
   traitcont,                          { type trait contours                }
   traitgrille,
   choi,
   cp1,  cp2,                          { clture premier profil             }
   cp3,  cp4,
   cg1,  cg2,                          { clture gravi profil 2             }
   cg3,  cg4,
   ct1,  ct2,                          { clture sismi profil 3             }
   ct3,  ct4,
   cpi1, cpi2,
   cpi3, cpi4,                         { cltures initiales maxi            }
   cti1, cti2,
   cti3, cti4,
   cgi1, cgi2,
   cgi3, cgi4,
   nbst,                               { nombre de stations/lissage         }
   codask,                             { code ascii symbole sismes         }
   nbcorps                             { nombre de polygones calculs       }
                             : integer;

   coul_e,
   coul_c,
   c_trace,                            { numros des couleurs               }
   c_sismi,
   c_topo,
   c_gravi,
   c_corps,
   c_fpro,
   c_coup                              { numro couleur courante            }
                        : word;

   coefx,                              { coef fentre                       }
   x1, y1,                             { origine profil                     }
   x2, y2,                             { extrmit  profil                  }
   coefz,                              { coefficient valeur Z               }
   ech1,  ech2,  ech3,                 { chelles des profils               }
   longpro,                            { longueur profil                    }
   larg,                               { 1/2 largeur bande de projection    }
   pas,                                { pas entre stations profils rduits }
   dom,                                { domaine pour moyenne mobile        }
   dens,                               { densit de l'eau                   }
   minsismi, maxsismi,                 { profil 1                           }
   mintopo,  maxtopo,                  {        2                           }
   ming,     maxg,                     {        3                           }
   hmin,     hmax,                     { hauteur symbole                    }
   heti                                { hauteur tiquettes courbes         }
                        : real;

   titrz1,
   titrz2,
   titrz3
                        : chainecar;

   compare,                            { comparaison profils brut/rduit    }
   echelle1,                           { visu profil aux normes             }
   legend,                             { affichage graduations profils      }
   visusymb,                           { affichage points grille ou sismes }
   anom,                               { fichier Anomalies demand          }
   reduc,                              { Rduction effectue                }
   modipro,                            { profil modifi                     }
   sismi, gravi, topo,                 { profil courant                     }
   sis,   top,   gra,                  { profil calcul                     }
   age,   flu,   sub,{sidence thermique, ajouts F.B. ...}
   visu1, visu2, visu3                 { profil affich                     }
                        : boolean;

   nomfd3                              { donnes 3 : sismes/points         }
                        : namestr;

   nomffong                            { fond de carte gravi                }
                        : pathstr;

IMPLEMENTATION

BEGIN
     nomdumodule := 'COUP';
     extpar      := '.CPS';            { Paramtres du travail en cours     }
END.

{ GEOCEAN - COUP_VAR ------------------------- R.C.- INRP - TOULOUSE - 1995 }

