PROGRAM ExOcean_INRP;

{---------------------------------------------------------------------------}
{  Programme principal du  logiciel ExOcean_INRP version 0.1 du  01.09.93   }
{  Adaptation  l'interface GEOCEAN du 11.03.94, rvise le      17.08.94   }
{                                                rvise le      00.00.94   }
{                                                rvise le      02.02.95   }
{---------------------------------------------------------------------------}
{  Application : Franois BORIE 40 Bld de la Paix 92400 Courbevoie          }
{  Interface graphique : A R X                                              }
{  A R X - Alain, Roger et Xavier CULOS - 6 avenue de Lagarde 31130 BALMA   }
{---------------------------------------------------------------------------}

{---------------------------------------------------------------------------}
{ fichiers spciaux associs au logiciel ExOcean                           }
{ *  *       .SMB            symboles                         dans rep CFG  }
{ *  ExO    .ICN            images, icnes                   dans rep CFG  }

{ fichiers spciaux associs  ce programme                                 }
{ *  ExO    .PAL            palette                          dans rep CFG  }
{    ExO    .TXT            mini documentation du programme  dans rep PRG  }
{ *  ExO    .HLP            texte d'aide obligatoirement     dans rep PRG  }

{ *  ExO    .CFG            paramtres de configuration      dans rep CFG  }
{ *  ExO    .INI            paramtres d'environnement       dans rep DNN  }
{ *  ExO    .par            paramtres du travail en cours   dans rep ct   }
{---------------------------------------------------------------------------}
{ fichiers de donnes                                                       }
{            .dat                                                           }
{ *  CONTI   .bln            carte                                          }
{---------------------------------------------------------------------------}
{ demos                                                                     }
{    ExO    .GAL             crer avec Deluxe paint                      }
{---------------------------------------------------------------------------}

{$M 65520,0,517000}

USES
   Exo_Rec,
   CSI,Icones,
   Graphism,PERIPHS,UtilDivs,
   MENUS,            { interface  menus droulants ( menu1  menu6  )       }

   GEO_VAR,          { variables globales communes                          }
   GEO_DES,

   ExO_VAR,          { variables globales propres au module                 }
   ExO_INI,          { initialisations    : lecture du fichier .INI         }
                     {             utilise PROG_DES, LIPAR                  }
   ExO_DES,          { graphisme                                            }
                     {                                                      }
   ExO_5,            { menu : SORTIES                                       }
                     {             utilise PROG_DES                         }
   ExO_4,            { menu : ECRAN                                         }
                     {             utilise                                  }
   ExO_3,            { menu : LEGENDES                                      }
                     {             utilise                                  }
   ExO_2,            { menu : ExOcean                                       }
                     {             utilise                                  }
   ExO_1;            { menu : FICHIERS  gestion des rpertoires             }
                     {             utilise DIRINFO                          }
   {------------------------------------------------------------------------}

{$O geo_var}
{$O geo_des}

{$O dirinfo}
{$O graphuti}
{$O graphplt}
{$O lipar}
{$O fichiers}
{$O Comment}
{$O periphs}
{$O utildivs}
{$O rs2322}
{$O sekoplt}
{$O imprim}
{$O fctmath}
{$O Imp_Portr}
{$O IGRF_}
{$O ExO_Ini}
{$O ExO_Des}
{$O ExO_Var}
(*{$O Generic}*)

{$O ExO_1}
{$O ExO_2}
{$O ExO_3}
{$O ExO_4}
{$O ExO_5}

procedure CasMenus;
   var
      Choix : integer;

   begin
      menu (a, b, codeclavier)  ;
     { help (codeclavier);}      { acquisition d'un choix valide dans un menu }
      if FF1 (codeclavier) then   { appui sur la touche F1 dans un sous-menu   }
         aide (a, b)
      else
         if b > 1 then
         Choix := 100*a+b;
         case Choix of           { validation d'une option dans un sous-menu  }
            { menu FICHIERS }
            102  : NOUVEAU_FICHIER;                   { 1 }
            103  : OUVRIR_FICHIER;                    { 1 }
            104  : ENREGISTRER_FICHIER;               { 1 }
            105  : ENREGISTRER_SOUS;                  { 1 }
            106  : VOIR_CATALOGUE;                    {   }

            108  : QUITTER;                           { 1 }
            109  : sauv_exo_reg;
            110  : SUPPRIMER_LIEN;                    { 1  p }
            111  : MODIFIER_LIEN;                     { 1  p }
            112  : VOIR_PARAMETRES;                   { 1  p }

            { menu ExO     }
            202  : AfficheParamModule;
            203  : AfficheParamRegion;
            204  : AfficheParamProfil;
            205  : AfficheParamChamp ;
            206  : AfficheParamCalcul;
            208  : Ajuste;
            209  : DecoupeCampagne;

            { menu LEGENDES    }
            302  : COMMENTAIRES;                      { 3 }
            303  : modif_couleurs1;                   { 3  }
            305  : modif_couleurs2;                   { 3 prof }

            { menu  ECRAN }
            402  : visu_carte;        { nouveau_fichier  4 }
            403  : visu_contours;                      { 4 }
            404  : visu_bathy;                         { 4 }
            405  : visu_symboles;                      { 4 }
            406  : visu_traces;                        { 4 }
            407  : If VisuCarte then Visu_Toponymie
                                else visu_commentaires;{ 4 }
            408  : visu_echelle_inversions;
            409  : zoom(ZoomActif);
            { menu SORTIES }
            502  : impr_params ('Configuration : ',        ParExo);
            503  : impr_params ('Paramtres de rgion : ', Params);
            504  : impr_params ('Paramtres de profil :',  ParProfil);
            505  : impr_params ('Paramtres de champ  :',  ParChamp);
            506  : impr_params ('Paramtres de calcul :',  ParCalcul);
            507  : COPECRAN;                          { 5 }
            508  : TRACE_GRAPH;                       { 5 }

            510  : PALETTES (nomdumodule);            { Geo_des }
            511  : CONFIG_PERIPH;                     { Geo_des }
            512  : CFG_PLUMES;                        { 5 }
{            509  : IMPR_PARAM;                        { 5 prof }

          { menu AIDES }
            602  : AIDE_MENUS_boites (cheminmodule+nomdumodule+exthlp);                        { ini }
            603  : aide (6, 3);
            604  : aide_geoc;
            605  : aide_module;
            606  : aide_region;
            608  : a_propos;
         end;
   end;

procedure CasIcones;
   var
      PosCur,
      Touche : integer;

   begin
      PosCur := 11;
      if affichetexte            { appui sur F1 au niveau d'une icne       }
      then
         case Zi of                                                   { CSI }
             1 : aide_geoc;      {}
             3 : aide (2, 5);   {  }
             4 : aide_module;   {  }
         end
      else
         case Zi of                                             { CSI }
             1 : A_propos;
             2 : version_logiciel;
             3 : If Etape < EtapeAjusteModele then ajuste
                                              else Retrace(True,False,False,ModiParamCalcul);          {  }
             4 : aide_region;
             5..8 : Begin MarquerIcone (IDors+4,CoulEcran);{Active_Icone(IDors+4);}
                          MarquerIcone (Zi,CoulBoite XOR C_Limite);{Inactive_Icone(zi);}
                          Hypotheses.Modele;
                          casmodele (zi-4) ;laide ('');end;

             9  : Begin MarquerIcone (Zi,CoulBoite XOR C_Vitesse);{Inactive_Icone(zi);}
                        If Etape=EtapeAjusteModele then vitesses
                                                   else VitesseInitiale;
                        MarquerIcone (Zi,CoulEcran);laide ('');end;
             10 : Begin MarquerIcone (Zi,CoulBoite XOR C_Limite);{Inactive_Icone(zi)};
                        Blocs ;
                        MarquerIcone (Zi,CoulEcran);laide ('');end;
             11 : Begin MarquerIcone (Zi,CoulBoite XOR C_Position);{Inactive_Icone(zi);}
                        If Etape=EtapeAjusteModele then position('Partez du profil calcul.'{,False})
                           else if visuechelle then position('Partez de l''chelle des inversions'{,True})
                                               else PositionInitiale;
                        MarquerIcone (Zi,CoulEcran);laide ('');end;

             12..17 : Begin MarquerIcone (Zi,CoulBoite);{Inactive_Icone(zi);}
                        ParamCalculSpeciaux(zi);
                        MarquerIcone (Zi,CoulEcran);laide ('');end;
            100 : ages  ;
            110 : Echelle;
         else castrace (zi);
         end;
   end;

procedure CasFenetre;
   begin
      Case Etape of
             EtapeCarteNouveau,EtapeCarteSynthese :
                  CasTrace (zi);
             EtapeObserveDonnees,EtapeDonneesInitiales,EtapeAjusteModele :
                  begin ModifieIndex(C_index,False);
                        XIndexTerrain:=AbcisseTerrain(XIndex) end;
       end;
      If VisuCarte then if visutoponym then Editer_noms(xs, ys, db)else
                   else if visucomm then begin ModiParamCalcul := true;
                           Editer_Commentaires (xs, ys, db)end;
   end;

BEGIN
   {Graphism.Black:=15;Graphism.White:=0; {activer pour captures sur fond blanc}
   iniparam        ;           { initialisation des paramtres par dfaut   }
                               { lecture des fichiers .CFG    }
   inimenus        ;           { initialisation de l'interface menus        }
   iniparam2 ;       { initialisation des paramtres par dfaut REGION.par }
   iniicones;                  { affichage des icones                       }
   inifondecran;
   inisymboles;      { initialisation des polices de symboles      CART_DES }

   inidonnees;
   Ini_Noms        ;
   iniecran        ;           { initialisation de l'cran/ExO              }
   iniaide         ;           { initialisation de l'aide en ligne          }
                               {      lecture de   fic.AID                  }
   repeat
      modif_menus_icones;   { modifications fonction des paramtres }
      case ZoneDuClick (maxc1, maxc2, maxc3, maxc4) of
         1 : CasMenus;
         2 : CasIcones;
         3 : casfenetre;
      end;
      if changemenus then inversemenus;
   until fini;
   fin;
END.

{--- ExO   ---------------------------------- R.C.- INRP - TOULOUSE - 1993 }

Modifications en projet :
  + Paramtrage des affichages :
     * Zoom sur la carte ou sur les profils en cours de travail
       OK mais plante quand zone dfinie trop petite
     * superposition des tracs bathymtriques et magntiques sur la carte
       OK, mais est-ce lisible ?
     * Paramtrage de l'chelle verticale d'affichage de la bathymtrie
     sur les coupes
     * Paramtrage de l'exagration verticale des profils sur la carte
       OK en passant par le fichier de paramtres de rgion,
       (variable AmplitudeProfils)
       doit pouvoir se faire directement  l'cran avec un curseur
     * Affichage de la valeur de la bathymtrie et de l'anomalie au niveau
     de l'index
       Pas pour tout de suite
     * affichage des noms de priodes sur l'chelle
       Utiliser des zones sensibles sous chaque anomalie,
       ne pas oublier de librer aprs usage!
     * Sur l'chelle des inversions, donner les noms des inversions
       C'est pareil !

  + Fonctionnalits de calcul du modle :
     * Ages limites de calcul du modle diffrents  droite et  gauche
       GASP !
     * Ages limites d'affichage de l'chelle des inversions IDEM (=> boutons
      action non symtrique, en lien avec le type de modle envisag)
     * dcoupage dynamique des profils
       Urgent, mais coton pb d'encombrement mmoire...
     * affichage de donnes ponctuelles : seismes
                                          flux thermique
                                          volcans
                                          age du sdiment le plus ancien
                                          paisseur de sdiments
       En cours (utiliser les procdures existantes dans CART...)
     * Modifier le triple curseur pour affichage de l'chelle :
                le bouton central disparat, il est constitu
                par l'ensemble de la barre
       FAIT !
     * action directe sur l'chelle des inversions pour interprter
     le profil observ (dplacement et lastique comme sur le profil calcul)
       Urgent, en cours !
     * Placer les valeurs d'ges des inversions dans un fichier externe
     * Rendre consultable (en aide par exemple) les ges des inversions
       Utile, mais il faut le temps de la faire...
