UNIT GEO_VAR;

   {------------------------------------------------------------------------}
   {      logiciel GEOCEAN                                                  }
   {                       variables globales communes                      }
   {                                                  1.1  fvrier 95       }
   {------------------------------------------------------------------------}

   (*
   GEO_var;                  { GEO     - variables globales GEOCEAN         }
   *)

INTERFACE

{$O+,F+}

USES
   Dos,                      { TP 70   - units standard Borland            }
   Lipar,                    { ARX     - Gestion des listes de paramtres   }
   Messarx,                  { ARX     - Textes des Messages de Base        }
   Utildivs,                 { ARX     - utilitaires divers                 }
   Comment;                  { ARX     - gestion des textes/page            }

CONST
   nomlogiciel   = 'GEOCEAN';     { nom de l'ensemble des modules           }

   degkm         =  111.111;      { longueur d'un portion de mridien de 1 }
   extcfg        = '.CFG';        { ext. fichier paramtres config module   }
   extcom        = '.DXT';        {                       et donnes textes }
   exthlp        = '.AID';        {              texte aide                 }
   extsmb        = '.SMB';        {              symboles                   }
   exticn        = '.ICN';        {              icnes                     }
   extgrd        = '.GRD';        {              DONNEES grille             }
   exteti        = '.ETI';        {              etiquettes pour...         }
   extblf        = '.BLF';        {              fonds de cartes en courbes }
   extbln        = '.BLN';        {              contours 2d                }
   extblz        = '.BLZ';        {              contours 3d                }
   exttop        = '.DAP';        {              toponymie                  }
   exttxt        = '.TXT';        {              texte aide Rgion /Module  }
   nomfinfo      = 'INFO.DIR';    { fichier ressource du rpert. de travail }
   nomfinfod     = 'INFOD.DIR';   { fichier ressource du rpert. de donnes }
   fic_etat_util = 'UTILISAT.eur';{ tat du travail pendant une session     }
   nombgi        = 'REPBGI';      { nom variable DOS= chemin BGI            }
   nom_graval    = 'GRAV_AL';     { nom donnes air libre                   }


   { noms des programmes modules }
   nom_cart       = 'CART';
   nom_bloc       = 'BLOC';
   nom_nuag       = 'NUAG';
   nom_coup       = 'COUP';
   nom_grav       = 'GRAV';
   nom_exoc       = 'EXOC';
   nom_ages       = 'AGES';

   { Extensions des fichiers de travail }
   ext_cart       = '.CRT';
   ext_bloc       = '.BLC';
   ext_nuag       = '.NGS';
   ext_coup       = '.CPS';
   ext_grav       = '.GRV';
   ext_exoc       = '.EOA';

   {$I geo_msg.pas}               { messages en franais }

VAR
   txtmenu,                       { couleurs menus et botes diverses       }
   fondmenu,
   txtnorm,
   txtnon,
   txtoui,
   fondnorm,
   fondoui,
   fondaide,
   c_carte,
   c_grille,
   c_bord,
   c_titr,
   c_axex,
   c_axey,

   coul_t,                             { couleur toponymie                  }

   nbpg_t,                             { nombre de poignes                 }
   align_t                             { justification toponymie            }
                             : word;

   parini ,                            {           initialisation du module }
   params                              {           de travail               }
                             : lipar.liste;

   nbti_xy,  {nbti_z,}                 { nb tirets intermddiaires         }
   htir_xy,  {htir_z,}                 { hauteur des tirets en mm           }
   nbdec_xy, {nbdec_z,}                { nombre de dcimales graduations    }
   hcar_xy,  {hcar_z, }                { hauteur tiquettes graduations     }
   maxc1, maxc2,
   maxc3, maxc4,                       { extension maxi clture             }
   cc1,  cc2,
   cc3,  cc4,                          { cloture courante                   }
   codeclavier,                        { code touche enfonce               }
   a, b,                               { position menus                     }
   ChoixModele               : integer;

   {v_indef,                            valeur indfinie  grille            }
   degkm_r,                            { coef de correction planisphre     }
                                       {  appliquer  degkm                }
   haut_t,                             { hauteur toponymie                  }
   { angl_t,}                          { angle toponymie                    }
   fc1,  fc2,  fc3,  fc4,              { fenetre principale                 }
   cor1, cor2, cor3, cor4,             { coordonnes carte                  }
   coef_c,                             { coef cloture                       }
   inter_xy{, inter_ez}                { intervalles graduations            }
                             : real;

   repbgi,                             { rpert. initialisations graphiques
                                         Borland : BGI et CHR communs aux
                                         modules et  l'interface MENU      }
   cheminexemples,                     { chemin complet exemples            }

   chemindonnees,                      { chemin complet donnes             }

   cheminmodule,                       { chemin complet module              }

   chemincfg,                          { chemin complet config machine      }

   nomffond                            { fichier fond de carte et etiq      }
                             : pathstr;

   extpar                              { extension fichier paramtres       }
                             : extstr;

   nomfcomm,                           { nom du fichier des commentaires    }
   nomftop,                            { nom du fichier toponymie           }
   nomdumodule,                        { nom du programme                   }
   region,                             { nom du rpertoire REGION           }
   nomfcfg,                            { nom fichier config                 }
   nomfpar,                            { paramtres de travail         .par }
   nomfcart,                           { fichier contours              .BLN }
   nomfd, nomfd2,                      { fichiers de donnes           .GRD }
   symb1, {symb2,} symb3               { fichiers symboles             .SMB }
                             : namestr;

   fdg                                 { Format donnes grille              }
                             : string [3];

   unitag,                             { nom unit d'ge                    }
   unitflux,                           { nom unit de flux                  }
   unitg,                              { nom unit gravi                    }
   unitl,                              { nom unit longueurs profil         }
   unite,                              { nom unit coordonnes xy           }

   titre,
   titr1,
   titr2,
   titr3,                              { titres  div.                       }
   unitxy, unitz,                      { units axes                        }
   nomutil,                            { nom de l'utilisateur prvu         }
   vindef                              { forme texte de la valeur indef     }
                             : t12;

   chain                               { var temporaire                     }
                             : string;

   TexteFonction             : longchaine;
                                       { Contiendra la formule de traitement
                                         des donnes lors du chargement
                                         d'une grille }
   TraitementAutorise,                 { Autorise ou non l'introduction d'une
                                         formule de traitement des donnes
                                         lors du chargement d'une grille}

   unicolore,                          { bloc limite NUAG une seule couleur }
   rapide,                             { micro rapide > triangles BLOCS     }
   reaffiche,                          { raffichage automatique demand    }
   deux_d,                             { 2 dimensions et non 3 : bloc, nuag }
   visufond,                           { fond de carte suppl. lu sur disque }
   {moditop,}                            { Toponymie modifie                 }
   modicomm,                           { Commentaires ou noms modifis      }
   fond_t,                             { fond des noms effac               }
   exempl,                             { accs demand aux exemples         }
   airlibre,                           { VRAI si anomalie A L               }
   visutoponym,                        { V : toponymie demande             }
   gradauto,                           { graduation automatique             }
   fini,                               { sortie du progranmme               }
   modipar,                            { paramtres de calcul modifis      }
   prof,                               { accs aux menus tendus            }
   visucarte,                          { carte dj affiche (ou graph ppal)}
   visugrad,                           { graduations externes demandes     }
   visucomm,                           { commentaires demands              }
   visucontours,                       { contours demands                  }
   visugrille,                         { affichage des points d'une grille  }
   visuzones,                          { V : zones de couleur prioritaires  }
   ok                                  { var temporaire                     }
                             : boolean;

   Noms,                             { coordonnes des noms  (toponymie)    }
   Annotations                       { attributs et textes des commentaires }
                             : PListeComment;

   NomEtab,                          { Nom de l'tablissement               }
   NumEtab                           { Numro national tab                 }
                             : chainecar;


IMPLEMENTATION

END.

{--- GEOCEAN - GEO_VAR ----------------------- R.C.- INRP - TOULOUSE - 1995 }

