UNIT boites;
INTERFACE
USES
    graph,
    utildivs,
    menus;


IMPLEMENTATION

procedure affich (h, lx, ly, mxx, mxy, x0, y0, nx, ny : integer);
   { position de dpart pour l'affichage : x0, y0 et nx, ny,
     longueur du texte                     y
     dimensions de la fentre texte        lx, ly et mxx, mxy
                             entte :      h                      }
   var
      debx, deby, i     : integer;

   begin
      debx := nx;
      deby := ny;
      setcolor        (c_t_boite_norm {colord});
      setfillstyle (1, c_f_boite_norm {colorf});
      i := deby;
      bar (x0+2, y0+h+2, x0+lx-2, y0+ly-2);
      repeat
         {        dx = 6, dy = 6 }
         outtextxy (x0  +6,
                    y0+h+6+(i-deby)*ty,
                    copy (listchaine^[i], debx, mxx));
         inc (i);
      until (i >= deby+mxy);
   end;

procedure affiche_entete (titre : string; x0, y0, lx, h : integer);
   begin
      setcolor        (c_t_boite_inve {colorf});
      setfillstyle (1, c_f_boite_inve {colord});
      bar             (x0+3,    y0+3,    x0+lx-3, y0+h-2);
      settextjustify  (1, 1);
      outtextxy       (x0+h +((lx-h) div 2), y0+(h div 2), titre);
      rectangle       (x0+4,    y0+4,    x0+h-4,  y0+h-4);
      { bouton fermeture }
      setfillstyle (0, c_t_boite_inve {colorf});
      settextjustify  (0, 2);
   end;

procedure bte_compl  (titre                      : string;
                      x0, y0, x, y, mxx, mxy     : integer );

   { boite complte -  1 ligne = titre si non vide
                    -  position initiale du coin sup g de la bote,
                    -  dimensions du texte
                    -  dimensions de la fenetre          }

   var
      p                             : pointer;
      dx, dy, lx, ly,
      bx, by, xok, yok,
      taillep                       : word;
      nx, ny, h, hb,
      xx, yy, supx, supy            : integer;
      chaine                        : string;
      centre, entet, confirm,
      asc_v, asc_h, reaffiche       : boolean;

   procedure affiche_bouton;
      begin
         rectangle (x0+xok,       y0+yok,  x0+xok+bx, y0+yok+by);
         settextjustify (1, 1);
         outtextxy (x0+xok+bx div 2, y0+yok+by div 2, 'OK');
         settextjustify (0, 2);
      end;

   function bouton_ok : boolean;
      begin
         bouton_ok :=
                   (xs > x0+xok) and (xs < x0+xok+bx)
               and (ys > y0+yok) and (ys < y0+yok+by);
      end;

   function bouton_fermeture : boolean;
      begin
         bouton_fermeture :=
               (xs > x0+4)   and (ys > y0+4)
           and (xs < x0+h-4) and (ys < y0+h-4)
           or d;
      end;

   begin
      memok := true;
      confirm := false;   { pas utilis dans cette version }
      asc_v := false;
      asc_h := false;
{         setfillstyle    (1, c_f_boite_norm );}
{         bar             (0, maxy-ty, maxx, maxy);}
      supx := 0;
      supy := 0;
      nouveau_style   (0, 0, 1);
      if mxx = 0  then mxx := x;
      if mxy = 0  then mxy := y;
      if y <= mxy then mxy := y
                  else begin supx := 2*tx; asc_v := true end;
      if x <= mxx then mxx := x
                  else begin supy := 2*tx; asc_h := true end;

      h    :=  0; { hauteur du titre }
      hb   :=  0; { hauteur libre pour les boutons intrieurs }
      ty   := 12;
      dx   :=  6;
      dy   :=  ty div 2;
      entet := titre <> '';
      if entet then h := 2*dy + ty;

      lx   := mxx*tx + dx*2;
      ly   := mxy*ty + dy*2 + h;
      if confirm
      then begin
         bx  := 2 * (2*dx +tx);
         by  := 2*dy + ty;
         hb  := by + dy;
         xok := (lx-bx) div 2;
         yok := ly-by-dy+hb;
      end;
      if (x0 < 0) or (y0 < 0)
      then
         if (POSXBTN =0)
         then begin
            x0 := (maxx-lx-supx)    div 2;
            y0 := (maxy-ly-supy-hb) div 2;
         end else begin
            x0 := (posxbtn-lx-supx) div 2;
            y0 := (maxy-ly-supy-hb) div 2;
         end;

      taillep := imagesize (0, 0, lx+supx, ly+supy+hb);
      if (taillep < maxavail) and (taillep < maximage)
      then begin
         taillep := imagesize (0, 0, lx+supx, ly+supy+hb);
         getmem (p, taillep);

         ny := 1;
         nx := 1;
         repeat
            reaffiche := false;
            getimage          (x0,   y0,    x0+lx+supx, y0+ly+supy+hb, p^);
            setcolor        (c_t_boite_norm {colord});
            setfillstyle (0, c_f_boite_norm {colorf});
            bar       (x0,   y0,       x0+lx,      y0+ly+hb);

            if asc_v
            then
               bar    (x0+lx,y0,       x0+lx+supx, y0+ly+hb);

            if asc_h
            then
               bar    (x0,   y0+ly+hb, x0+lx,      y0+ly+hb+supy);

            rectangle (x0+1, y0+1,     x0+lx-1,    y0+ly+hb-1);

            if entet
            then
               affiche_entete (titre, x0, y0, lx, h);

            if asc_v
            then
               affiche_ascenseur_v (1, y-mxy+1, x0+lx-1, y0+1, ly+hb-2, -1, ny);
            if asc_h
            then
               affiche_ascenseur_h (1, x-mxx+1, x0+1, y0+ly+hb-1, lx-2, -1, nx);

            affich (h, lx, ly, mxx, mxy, x0, y0, nx, ny);

            if confirm
            then
               affiche_bouton;
            xx := x0;
            yy := y0;
            repeat
               if asc_v
               then
                  ascenseur_v (1, y-mxy+1, x0+lx-1, y0+1, ly+hb-2, -1, ny);
               if asc_h
               then
                  ascenseur_h (1, x-mxx+1, x0+1, y0+ly+hb-1, lx-2, -1, nx);
               if (not asc_h) and (not asc_v)
               then begin
                  MontrerSouris;
                  clavsouris;
         if touche then
            case CodeClavier of
               FleH : begin
                         y2 := y;
                         repeat
                            y := (y-3+Long^[x1, 1]) mod (Long^[x1, 1]) +2;
                         until Menu1^[x1, y].etat or (y = y2);
                      end;
               FleB : begin
                         y2 := y;
                         repeat
                            y := (y-1) mod (Long^[x1, 1]) +2;
                         until Menu1^[x1, y].etat or (y = y2);
                      end;
            end
                  LirePositionSouris (xs, ys);
                  CacherSouris;
               end;

               affich (h, lx, ly, mxx, mxy, x0, y0, nx, ny);

               if (xs > x0+h) and (xs < x0+lx) and (ys > y0) and (ys < y0+2*ty)
                  and (not d)
               then begin
                  dep_rec (xx, yy, lx+supx, ly+supy+hb);
                  LirePositionSouris (xs, ys);
                  reaffiche := true;
                  g := BoutonSourisEnfonce (BoutonGauche);
                  d := BoutonSourisEnfonce (BoutonDroit);
               end;
               if confirm then d := bouton_ok;
               if entet   then d := bouton_fermeture;
            until d or reaffiche;

            putimage (x0, y0, p^, 0);
            x0 := xx;
            y0 := yy;
         until not reaffiche;
         putimage (x0, y0, p^, 0);
         libere   (p);
      end else
         memok := false;
      ancien_style;
   end;

procedure lit_sous_m;
   begin
      MontrerSouris;
      sortie  := false;
      fin     := false;
      CodeClavier := 0;
      Touche  := false;
      relache := not BoutonSourisEnfonce (BoutonGauche);
      repeat
         if touche then
            case CodeClavier of
               FleH : begin
                         y2 := y;
                         repeat
                            y := (y-3+Long^[x1, 1]) mod (Long^[x1, 1]) +2;
                         until Menu1^[x1, y].etat or (y = y2);
                      end;
               FleB : begin
                         y2 := y;
                         repeat
                            y := (y-1) mod (Long^[x1, 1]) +2;
                         until Menu1^[x1, y].etat or (y = y2);
                      end;
            end
         else begin
            LirePositionSouris (xs, ys);
            y :=  trunc ((ys-hm-dd0)/ty)+2;  { rc 07/06}
         end;

         if ascen or touche
         then begin
            CacherSouris;
            if (y1 > 1) and (y1 < long+2)
                        and (menu1^[x1, y1].etat)
            then begin
               setfillstyle (SolidFill, c_f_boite_norm);
               bar (lmenu+dd0,                   (y1-2)*ty+hmenu+dd0 -1,
                    lmenu+long^[x1, 3]+2*tx-dd0, (y1-2)*ty+hmenu+dd0 +ty);
               setcolor (c_t_boite_norm);
               outtextxy    (lmenu+tx,           (y1-2)*ty+hmenu+dd0, menu1^[x1, y1].titre);

               setfillstyle (SolidFill, c_barre);
               bar (0, maxy-ty, maxx, maxy);
            end;
            if (y > 1) and (y < long^ [x, 1]+2)
                       and (menu1^ [x, y].etat)
            then begin
               setfillstyle (SolidFill, c_f_boite_inve);
               bar (lmenu+dd0,                   (y-2)*ty+hmenu+dd0 -1,
                    lmenu+long^ [x, 3]+2*tx-dd0, (y-2)*ty+hmenu+dd0 +ty);
               setcolor (c_t_boite_inve);
               outtextxy (lmenu+tx,              (y-2)*ty+hmenu+dd0,
                          menu1^ [x, y].titre);

               setcolor     (c_t_boite_norm);
               settextjustify (1, 2);
               outtextxy    (maxx div 2, maxy-ty + 1,
                             menu1^[x, y].commentaire);
               settextjustify (0, 2);
            end;
            MontrerSouris;
            x1    := x;
            y1    := y;
            test2 := false;
            test  := true;
         end else begin
            y := y1;
            x := x1
         end;
         fin := sortie;

         if (not relache) and (not BoutonSourisEnfonce (BoutonGauche))
         then sortie := true;

         g := BoutonSourisEnfonce (BoutonGauche);
         while (not fin) and (relache and not g) do begin
            Touche := ToucheClavier (CodeClavier);
            if Touche then begin
               g := true;
               sortie := (CodeClavier = CR) or (CodeClavier = ESC)
            end else begin
               g := BoutonSourisEnfonce (BoutonGauche);
               sortie := true;
            end;
         end;
         LirePositionSouris (xs, ys);
         if (not touche) and (ys < ty+dd0)
                         and ((xs < (x1-1) * (maxx div nbboites))
                         or   (xs > 3+x1   * (maxx div nbboites)))
         then begin
            fin := true;
            relache := false
         end;
         if    (CodeClavier = FleD) or (CodeClavier = FleG)
            or (CodeClavier = CR)   or (CodeClavier = ESC)
            or (CodeClavier = F1)
         then fin := true;
      until fin;

      if Touche
      then begin
         if (CodeClavier = ESC) then y := 0;
      end else
         if
         then y := 0;
      CacherSouris;
      effaceboite (lmenu, hmenu, x);
      setfillstyle (SolidFill, c_barre);
      MontrerSouris;
   end;

procedure listes (texte1, texte2, texte3 : string; x : integer;
                 var rep : string; var indice : integer);
   var
      p                     : pointer;
      y, lx, ly,
      taillep               : longint;
      x0, y0,
      nn, n, memy,
      debu, i, max, h       : integer;

   procedure affiche;
      var
         pp,   i       : integer;
         nomf, ext     : string;

      begin
         if n >      (y div 2)
         then debu := n-(y div 2)+1
         else debu := 1;

         if n >= max-(y div 2)
         then debu := max-y+1;
         i := debu;
         repeat
            if i <> n
            then begin
               setcolor                (c_t_boite_norm);
               setfillstyle (SolidFill, c_f_boite_norm);
            end else begin
               setcolor                (c_t_boite_inve);
               setfillstyle (SolidFill, c_f_boite_inve);
            end;
            bar         (x0   +2,   y0+h+1 +(i-debu)  *ty,
                         x0+lx-2,   y0+h   +(i-debu+1)*ty);
            pp := pos ('.', (listchaine^[i]));
            if (pp > 3) and (pp < 9)
            then begin
               nomf := copy  (listchaine^[i], 1,    pp-1);
               ext  := copy  (listchaine^[i], pp,   4   );
               outtextxy (x0+6,       y0+h+(i-debu)*ty, nomf);
               outtextxy (x0+6+tx*8,  y0+h+(i-debu)*ty, ext);
            end else                                     { liste banale  }
               outtextxy (x0+6,       y0+h+(i-debu)*ty,
                          copy (listchaine^[i], 1, x));
            inc (i);
         until (listchaine^[i] = '') or (i = debu+y);
      end;

   begin
    {  nouveau_style (0, 0, 1);
      tx :=  8;
      ty := 12; }
      i  :=  0;
      repeat
         inc (i);
      until listchaine^[i] = '';
      y  := i-1;
      max:= y;
      n  := 1;
      if y > 10 then y := 10;
      if length (texte1) > x then x := length (texte1);
      if length (texte2) > x then x := length (texte2);
      if length (texte3) > x then x := length (texte3);
      lx := x*tx  + 2*6;
      h  := 3*ty  + 11;
      ly := h + ty*y + 2;
      taillep := imagesize (0, 0, lx, ly);

      if taillep < maxavail
      then begin
         laide ('Dplacer la slection avec la souris ou les flches puis valider');
         getmem (p, taillep);
         if posxbtn = 0
         then begin
            x0 := (maxx div 2)-(lx div 2);
            y0 := (maxy div 2)-(ly div 2);
         end else begin
            x0 := (posxbtn div 2)-(lx div 2);
            y0 := (maxy div 2)-(ly div 2);
         end;
         getimage  (x0,   y0,   x0+lx,   y0+ly, p^);

         setcolor        (c_t_boite_norm );
         setfillstyle (0, c_f_boite_norm );
         bar       (x0,   y0,   x0+lx,   y0+ly);
         rectangle (x0+1, y0+1, x0+lx-1, y0+ly-1);
         rectangle (x0+1, y0+1, x0+lx-1, y0+ h-1);

         setcolor        (c_t_boite_inve );
         setfillstyle (1,  c_f_boite_inve);
         bar       (x0+2, y0+2, x0+lx-2, y0+h-2);
         settextjustify (1, 1);
         outtextxy (x0+lx div 2, y0+3+       ty div 2,  texte1);
         outtextxy (x0+lx div 2, y0+3+ty+    ty div 2,  texte2);
         outtextxy (x0+lx div 2, y0+3+ty+ty +ty div 2,  texte3);
         settextjustify (0, 2);
         nn   := n;
         memy := 0;
         affiche;
         repeat until not unboutonsourisenfonce;
         repeat
            g := BoutonSourisEnfonce (BoutonGauche);
            d := BoutonSourisEnfonce (Boutondroit);
            compteursouris (cx, cy);
            cy   := cy div 2;
            clav;
            if cy <> 0
            then cy := cy + (cy div abs (cy))*abs (memy)
            else cy := memy;
            n    := n + cy div ty;
            memy := cy mod ty;
            if n <  1   then  n  := 1;
            if n >  max then  n  := max;
            if n <> nn
            then begin
               affiche;
               nn := n
            end;
         until d or g;

         if d
         then begin
            rep := '' ;
            indice := 0
         end else begin
            rep := listchaine^[n] ;
            indice := n
         end;

         putimage (x0, y0, p^, 0);
         freemem  (p, taillep);
         laide ('');
      end;
      { ancien_style;}
   end;


END;