UNIT CART_3;

   {------------------------------------------------------------------------}
   {      logiciel CART                                                     }
   {                       Menu LEGENDES                                    }
   {                                                                        }
   {------------------------------------------------------------------------}

INTERFACE

{$O+,F+}

USES
   Symboles,                 { ARX     - traitement des donnes ponctuelles }

   GEO_var,                  { GEO     - variables globales GEOCEAN         }
   GEO_des,                  { GEO     - diverses procdures communes       }

   CART_var,                 { CART    - variables globales du module       }
   CART_des;                 { CART    - affichages propres au module       }

Procedure commentaires;
   { Ajouter une ligne de texte supplmentaire                              }

Procedure axes;
   { dfinit les paramtres des axes X et Y                                 }

Procedure d_CONTOUR;
   { dfinit les paramtres du trac des continents                         }

Procedure d_symboles;
   { dfinit les symboles  utiliser                                        }

Procedure v_zones_s;
   { affiche les symboles en mode ZONES                                     }

Procedure d_zonesymb;
   { dfinit des zones de symboles                                          }

Procedure d_toponymie;
   { dfinit les paramtres de la toponymie                                 }

Procedure Autres_params;
   { permet de raffecter des paramtres par dfaut                         }

Procedure ajouter_nom;
   { au fichier region.DAP                                                  }

{---------------------------------------------------------------------------}
IMPLEMENTATION

procedure commentaires;
   begin
      Ajouter_COMMENTAIRES (false); { non lies  la carte }                                       { geo_des }
      visucomm := true;
      Dessiner_commentaires (false, true, false);
      modipar := true;
   end;

procedure axes;
   begin
      if visugrad
      then
         graduer_exterieur_xy (false, true);        { effacer }

      choix_axes (htir_xy, hcar_xy, nbti_xy, nbdec_xy, inter_xy);

      if visugrad
      then
         graduer_exterieur_xy (false, false);    { re graduer }
      modipar := true;
   end;

procedure d_CONTOUR;
   var
      cc1,
      tt1         : byte;

   begin
      if visucontours
      then
         ajoute_contours (false, true);

      cc1          := byte (c_carte);
      tt1          := byte (traitcont);
      choix_couleur_trait (n_contours, cc1, tt1);                 { GEO_des }
      c_carte      := cc1;
      traitcont    := tt1;

      if visucontours
      then
         ajoute_contours (false, false);

      modipar := true;
   end;

procedure d_symboles;
   begin
      {  visusymb := true;}
      previsu := false;
      voir_essai;
      aff_min_max;

      choix_symboles (modipar);

      if reaffiche and visusymb
      then
         Effacer_tout_redessiner
      else begin
         voir_essai;
         aff_min_max;
      end;
   end;

procedure v_zones_s;
   begin
      visusymb    := true;
      visuzonesmb := not visuzonesmb;
      previsu     := false;
      voir_essai ;
      aff_min_max;

      if visuzonesmb
      then
         typedat := 5
      else begin
         typedat := 6;
         if rang_v <= 2 then typedat := 1;
      end;

      if (nb_zones (z_smb) = 0) and visuzonesmb
      then begin
         ajoute_une_zone_s;
      end;

      if reaffiche and visusymb
      then
         Effacer_tout_redessiner
      else begin
         voir_essai;
         aff_min_max;
      end;

      inietat ;
      modipar := true;
   end;

procedure d_zonesymb;
   begin
      visuzones := true;
      previsu   := false;
      voir_essai ;
      aff_min_max;

      ajoute_une_zone_s;

      if reaffiche and visusymb
      then
         Effacer_tout_redessiner
      else begin
         voir_essai;
         aff_min_max;
      end;

      modipar := true;
   end;

procedure d_toponymie;
   begin
      if visutoponym                                 { effacer symb courant }
      then
         effacer_noms;

      choix_toponymie (modipar);

      if visutoponym
      then
         dessiner_noms (false, true, false);
   end;

procedure Autres_params;
   var
      cc1, cc2,
      tt1         : byte;

   begin
      cc1          := byte (c_bord);
      cc2          := byte (c_grille);
      tt1          := byte (traitgrille);
      choix_param_autres (cc1, cc2, tt1, dmin, nbpi);
      c_bord       := cc1;
      c_grille     := cc2;
      traitgrille  := tt1;

      if reaffiche
      then
         Effacer_tout_redessiner;
      modipar      := true;
   end;

procedure ajouter_nom;
   begin
      ajouter_noms;
      visutoponym := true;
      modipar := true;
   end;

END.

{--- GEOCEAN - CART_3 ------------------------ R.C.- INRP - TOULOUSE - 1995 }
